#!/bin/sh
#devine.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: play_devine.tcl,v 1.9 2006/03/25 00:55:15 abuledu_francois Exp $
#  Author  : andre.connes@wanadoo.fr
#  Date    : 05/01/2003 Modification : 16/02/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

global fichier_image flagQuidonc
source devine.conf
source msg.tcl
source fin_sequence.tcl
source lanceapplication.tcl

set fichier_image [lindex $argv 0]
set flagQuidonc 0

  #
  # langue par defaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

  package require Img

####################################################
#
# selectionner_rect
#
####################################################

proc selectionner_rect { } {
  global list_rect
  
  foreach nrect $list_rect {
    set i [lindex $nrect 0]
    set j [lindex $nrect 1]
    .frame.can_image bind rect($i,$j) <Enter> ""
    .frame.can_image delete rect($i,$j)
  }
  .bframe.but_pouce configure -state normal

} ;# selectionner_rect

####################################################
#
# clicmotion
#
####################################################

proc clicmotion { i j } {
  global flagQuidonc
  variable toogleFlagQuidonc
  if {$flagQuidonc==1 && $toogleFlagQuidonc == 1} {
    .frame.can_image bind rect($i,$j) <Enter> \"\"
    .frame.can_image delete rect($i,$j)
  }
}

####################################################
#
# decouvrir_image
#
####################################################

proc decouvrir_image { } {
  global glob 

    # montrer toute l'image
    for { set i 0 } { $i < $glob(nbrow) } { incr i 1 } {
      for { set j 0 } { $j < $glob(nbcol) } { incr j 1 } {
        .frame.can_image delete rect($i,$j)
      } 
    }
    .bframe.but_pouce configure -state disabled
    .bframe.but_oeil configure -state disabled
}

####################################################
#
# zone_suivante
#
####################################################

proc zone_suivante { } {
  global glob list_rect cadre rect bgimage v_width v_height
  set glob(nzone) [expr $glob(nzone) +1]
  # si plus de zone pour cette image
  if { $glob(nzone) > $glob(nzone_total) } {
    .bframe.but_pouce configure -state disabled
    .bframe.but_oeil configure -state normal
  }
  set list_rect [lrange [lindex $glob(list_zones) $glob(nzone)] 1 end]
  # on fait apparaitre la zone
  foreach nrect $list_rect {
    set i [lindex $nrect 0]
    set j [lindex $nrect 1]
    .frame.can_image create rect [expr $glob(org) + $j*($v_width) +1] [expr $glob(org) + $i*$v_height +1] \
	  [expr $glob(org) + ($j+1)*$v_width -10] [expr $glob(org) + ($i+1)*$v_height -10] \
	  -fill $glob(bgcolor) -width 0 -tag rect($i,$j)
    #$.frame.can_image create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
	  [expr $glob(org) + ($j+1)*$v_width +1] [expr $glob(org) + ($i+1)*$v_height +1] \
	  -fill $glob(bgcolor) -width 1 -tag rect($i,$j) 
 
    .frame.can_image bind rect($i,$j) <Enter> "selectionner_rect"
  }
  .bframe.but_pouce configure -state disabled

} ;# zone_suivante

# #################################################################################
#
#                                   affiche_image
#
# #################################################################################

proc affiche_image { } {
  global glob bgimg bgimage v_height v_width fichier_image flagQuidonc
  .frame.can_image delete all
  
  # afficher le fond, fonction de l'image
  # de la liste des images sélectionnées

  set bgimg $fichier_image
  
  set bgimage [image create photo -file [file join images $bgimg]]

  set hbgimage [image height $bgimage]
  set wbgimage [image width $bgimage]

  .frame.can_image create image \
	[expr $glob(org) + int($wbgimage/2)+1] [expr $glob(org) + int($hbgimage/2)+1] -image $bgimage -tag imgfond

  # lire les caracteristiques de cette image : nb.lignes/colonnes + zones
  set nom_image [file rootname [file tail $bgimg]]
  set glob(list_zones) ""
  catch {  
    set f [open [file join [pwd] zones $nom_image] "r"] 
    set glob(list_zones) [gets $f]
    close $f
  }
  if { $glob(list_zones) ==""} {
    tk_messageBox -message [mc "Aucune zone détectée dans l'image"]
    return
  }
  # determiner le nombre de lignes et de colonnes de l'image actuelle
  set nb [lindex $glob(list_zones) 0]
  set glob(nbrow) [lindex $nb 0]
  set glob(nbcol) [lindex $nb 1]

  set v_height [expr ($hbgimage + $glob(nbrow)) / $glob(nbrow)]
  set v_width [expr ($wbgimage + $glob(nbcol)) / $glob(nbcol)]

  ####################Creation du tableau###################################
  # On utilise des rectangles pour dessiner les cases

    # on cache tout
    for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
        .frame.can_image create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
	  [expr $glob(org) + ($j+1)*$v_width +1] [expr $glob(org) + ($i+1)*$v_height +1] \
	  -fill $glob(bgcolor) -width 0 -tag rect($i,$j)
        .frame.can_image bind rect($i,$j) <Motion> "clicmotion $i $j"
      }
    }

    # on encadre toutes les zones
      .frame.can_image create rect [expr $glob(org) ] [expr $glob(org) ] \
	  [expr $glob(org) + $wbgimage] [expr $glob(org) + $hbgimage] \
	  -width 2

  # determiner le nombre de zones a devoiler
  set glob(nzone_total) [expr [llength $glob(list_zones)] -1]
  # initialiser le numero de zone a devoiler (0 au depart. La premiere sera 1)
  set glob(nzone) 0
  # initialiser la sauvegarde du texte total frappe par l'eleve
  set glob(zone_texte) ""
  # c'est parti !
    bind .frame.can_image <ButtonPress-1> "global flagQuidonc; set flagQuidonc 1"
    .frame.can_image bind imgfond <ButtonRelease-1> "global flagQuidonc; set flagQuidonc 0"

  zone_suivante

} ;# affiche_image

#####################################################################################
#
# fenetre principale
#
#      placement de la fenetre en haut et a gauche de l'ecran
#
#####################################################################################
#wm resizable . 0 0
#wm geometry . [expr [winfo screenwidth .]-10]x[expr [winfo screenheight .]-80]+0+0
wm geometry . 795x580+0+0
. configure -bg $glob(bgcolor)

frame .frame -bg $glob(bgcolor)
pack .frame -side top -fill both -expand yes

  # afficher le nom du theme
  wm title . "Devine [mc image] : [file rootname $fichier_image]"

# ################ On cree un canvas image ###########################################
# a gauche

canvas .frame.can_image -width 794 -height 496 -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack .frame.can_image -side left -expand true 

  
# ############# on cree une frame oeil, pouce, gagne, porte ##########################
# en bas

frame .bframe -bg $glob(bgcolor)
pack .bframe -side bottom -expand true

    button .bframe.but_oeil -image \
      [image create photo foeil \
      -file [file join sysdata oeil.png]] \
      -state disabled \
      -bg $glob(bgcolor) \
      -command "decouvrir_image"
    grid .bframe.but_oeil -padx 10 -column 0 -row 1

  button .bframe.but_pouce -image \
    [image create photo fpouce \
    -file [file join sysdata pouce.png]] \
    -bg $glob(bgcolor) \
    -command "zone_suivante"
  grid .bframe.but_pouce -padx 10 -column 1 -row 1

    checkbutton .bframe.but_quidonc -image \
      [image create photo fflag \
      -file [file join sysdata quidonc.png]] \
      -variable toogleFlagQuidonc \
	-bg $glob(bgcolor) \
	-command "global flagQuidonc; set flagQuidonc 0"
    grid .bframe.but_quidonc -padx 10 -column 2 -row 1

  button .bframe.but_quitter -image \
    [image create photo fquitter \
    -file [file join sysdata quitter_minus.png]] \
    -command "lanceappli devine.tcl"
  grid .bframe.but_quitter -padx 10 -column 3 -row 1

  set glob(nimage) 0
  
affiche_image
