#!/bin/sh
#devine_questions.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: play_devine.tcl,v 1.9 2006/03/25 00:55:15 abuledu_francois Exp $
#  Author  : andre.connes@wanadoo.fr
#  Date    : 05/01/2003 Modification : 16/02/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source devine.conf
source msg.tcl
source fin_sequence.tcl
source lanceapplication.tcl

set fichier_image [lindex $argv 0]

set glob(sysFont) {Helvetica 12 bold}

  #
  # langue par defaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

# Decommenter la ligne suivante si Img est installe
  package require Img

####################################################
#
# zone_suivante
#
####################################################

proc zone_suivante { } {
  global glob list_rect cadre rect bgimage v_width v_height

  set glob(nzone) [expr $glob(nzone) +1]
  .bframe.but_zoom configure -state disabled
  if { $glob(nzone) > $glob(nzone_total) } {
    # si plus de zone pour l'image
    return
  }
  
  # afficher la question
  set question [lindex [lindex $glob(list_zones) $glob(nzone)] 0] 
  .frame.can_texte insert end "$glob(nzone). $question : "

  set list_rect [lrange [lindex $glob(list_zones) $glob(nzone)] 1 end] 
  
} ;# zone_suivante

####################################################
#
# verifier_rect
#
####################################################

proc verifier_rect { i j } {
  global glob vignette list_rect v_width v_height

  if { $glob(nzone) == 0 } return
  set trouve 0  
  for { set k 0 } { $k < [llength $list_rect] } { incr k 1 } {
    if { [list $i $j ] == [lindex $list_rect $k] } { set trouve 1 }
  }
  if { $trouve } {
    for { set k 0 } { $k < [llength $list_rect] } { incr k 1 } {
      set i [lindex [lindex $list_rect $k] 0]
      set j [lindex [lindex $list_rect $k] 1]
      .frame.can_image create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
	  [expr $glob(org) + ($j+1)*$v_width +0] [expr $glob(org) + ($i+1)*$v_height +0] \
	  -width 1 -tag rect($i,$j) 
    }
    .frame.can_texte insert end "[mc Bravo] \n"
    .bframe.but_zoom configure -state normal
    if { $glob(nzone) >= $glob(nzone_total) } { 
      .bframe.but_zoom configure -state disabled
    }
  } else {
    .frame.can_image create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
	  [expr $glob(org) + ($j+1)*$v_width +0] [expr $glob(org) + ($i+1)*$v_height +0] \
	  -fill red -width 0 -tag rect($i,$j) 
    after 100 { set attente_erreur non }
    vwait attente_erreur
	.frame.can_image create image \
	  [expr $glob(org) + $j*$v_width  + $v_width/2] \
	  [expr $glob(org) + $i*$v_height + $v_height/2] \
	  -image vignette($i,$j) -tags rect($i,$j)
        .frame.can_image bind rect($i,$j) <Button-1> "verifier_rect $i $j "
    #incr glob(nberreurs)
  }
  
} ;# verifier_rect

# #################################################################################
#
#                           affiche_image
#
# #################################################################################

proc affiche_image { } {
  global glob fichier_image bgimage v_height v_width vignette

  .frame.can_image delete all
  .frame.can_texte insert end "\n"  
  # preparer les dimensions utiles pour afficher les zones de l'image

  set bgimage [image create photo -file [file join images $fichier_image]]

  set hbgimage [image height $bgimage]
  set wbgimage [image width $bgimage]

  # lire les caracteristiques de cette image : nb.lignes/colonnes + zones
  set nom_image [file rootname [file tail $fichier_image]]
#  set f [open [file join [pwd] zones $glob(theme) $nom_image] "r"] 
  set f [open [file join [pwd] zones $nom_image] "r"] 
  catch { [set glob(list_zones) [gets $f] ] }
  close $f
  # determiner le nombre de lignes et de colonnes de l'image actuelle
  set nb [lindex $glob(list_zones) 0]
  set glob(nbrow) [lindex $nb 0]
  set glob(nbcol) [lindex $nb 1]


  set v_height [expr $hbgimage / $glob(nbrow) +0]
  set v_width [expr $wbgimage / $glob(nbcol) +0]

  ####################Creation du tableau###################################
  # On utilise des rectangles pour dessiner les cases

  # on cree puis on affiche les vignettes
  for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
    for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
	image create photo vignette($i,$j)
	vignette($i,$j) copy $bgimage -from \
          [expr $j*$v_width]     [expr $i*$v_height] \
          [expr ($j+1)*$v_width -0] [expr ($i+1)*$v_height -0]
	.frame.can_image create image \
	  [expr $glob(org) + $j*$v_width  + $v_width/2] \
	  [expr $glob(org) + $i*$v_height + $v_height/2] \
	  -image vignette($i,$j) -tags rect($i,$j)
        .frame.can_image bind rect($i,$j) <Button-1> "verifier_rect $i $j "
    } ;#fin for
  } ;# fin for

  # determiner le nombre de zones a devoiler
  set glob(nzone_total) [expr [llength $glob(list_zones)] -1]
  # initialiser le numero de zone a devoiler (0 au depart. La premiere sera 1)
  set glob(nzone) 0
  .bframe.but_zoom configure -state normal
  
  # c'est parti ! zone_suivante
  
} ;# affiche_image

#####################################################################################
#
# fenetre principale
#
#      placement de la fenetre en haut et a gauche de l'ecran
#
#####################################################################################
#wm resizable . 0 0
#wm geometry . [expr [winfo screenwidth .]-10]x[expr [winfo screenheight .]-80]+0+0
wm geometry . 795x580+0+0

. configure -bg $glob(bgcolor)

  # l'afficher dans la barre de la fenetre
  wm title . "Devine [mc questions] : "

frame .frame -bg $glob(bgcolor)
pack .frame -side top -fill both -expand yes

# ################ On cree un canvas image ###########################################
# a gauche

canvas .frame.can_image -width 500 -height 496 -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack .frame.can_image -side left -expand true 

# ################ On y cree un canvas texte ########################################
# a droite

text .frame.can_texte -relief sunken -bd 2 -height 25 -width 27 -spacing2 5 -font $glob(sysFont)
pack .frame.can_texte -side left -anchor w -expand true 

.frame.can_texte insert 0.0 ""

# ############# on cree une frame pour les butons oeil, zoom, gagne, porte ##########
# en bas

frame .bframe -bg $glob(bgcolor)
pack .bframe -side bottom -expand true

  button .bframe.but_zoom -image \
    [image create photo fzoom \
    -file [file join sysdata quidonc.png]] \
    -command "zone_suivante"
  grid .bframe.but_zoom -padx 10 -column 1 -row 1

  button .bframe.but_quitter -image \
    [image create photo fquitter \
    -file [file join sysdata quitter_minus.png]] \
    -command "lanceappli devine.tcl"
  grid .bframe.but_quitter -padx 10 -column 3 -row 1

  set glob(nimage) -1

affiche_image
