#!/bin/sh
#devine.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: play_devine.tcl,v 1.9 2006/03/25 00:55:15 abuledu_francois Exp $
#  Author  : andre.connes@wanadoo.fr
#  Date    : 05/01/2003 Modification : 16/02/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source devine.conf
source msg.tcl
source fin_sequence.tcl
source lanceapplication.tcl
global fichier_image

set fichier_image [lindex $argv 0]

  #
  # langue par defaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

# Decommenter la ligne suivante si Img est installee
 package require Img

####################################################
#
# sauvegarde
#
####################################################

proc sauvegarde { } {
  global glob bgimg
  # sauvegarder les donnees de l'image actuelle
  if { [llength $glob(list_zones)] <= 1 } {
    return
  }
  catch { [file mkdir [file join [pwd] zones]] }
  set nom_image [file rootname [file tail $bgimg]]
  set f [open [file join [pwd] zones $nom_image] "w"] 
  puts $f $glob(list_zones)
  close $f
} ;# sauvegarde

####################################################
#
# ajouter_zone
#
####################################################

proc ok_zone { } {
  global glob can_img can_zones v_width v_height cache var_zone
  if { [string length $var_zone] > 2 } {
    set sysFont {Helvetica 15 bold} ;# {Geneva 15 bold}{Adobe-Courier 15 bold}
    set glob(nzone) [expr $glob(nzone) +1]
    # numero du carre-zone
    $can_zones create text 30 [expr 15*$glob(nzone)]  \
      -fill red -text "$glob(nzone). " ;# -tag nzone_$glob(nzone)
    # entree des mots-cles de la zone
    $can_zones create text 50 [expr 15*$glob(nzone)] \
      -fill black -anchor w -text "$var_zone" ;# -tag tzone_$glob(nzone) 
    # maintenir la liste des cases selectionnees
    set zliste [list $var_zone]
    for {set i 0} {$i < $glob(nbrow)} { incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1 } {
        if {$cache($i,$j) == 1} {
          lappend zliste "$i $j"
          set cache($i,$j) 9 ;# ne pas reutiliser
          $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
            [expr $glob(org) + ($j+1)*$v_width -1] [expr $glob(org) + ($i+1)*$v_height -1] \
            -fill red -tag rect($i,$j) -width 1
        }
      }
    }
    # maintenir la liste des zones
    lappend glob(list_zones) $zliste
    # desactiver le bouton pouce
    .bframe.but_pouce configure -state disabled
  }
} ;#ok_zone

proc ajouter_zone { can_zones } {
  global glob var_zone
  if { $glob(nzone) >=9 } {
   # return
  }
  #saisir_zone
  destroy .top_zone
  set tz [toplevel .top_zone]
  raise .top_zone
  wm title $tz "question"
  wm geometry $tz 420x140+380+560
  entry $tz.zone -textvariable var_zone
  button $tz.but_zone -text Ok -command "ok_zone; destroy .top_zone"
  pack $tz.zone -padx 20 -pady 40
  pack $tz.but_zone
  
} ;# ajouter_zone

####################################################
#
# selectionner
#
####################################################

proc selectionner_rect { can_img i j } {
  global glob cache rect v_width v_height
  if { $cache($i,$j) == 0 } {
      set cache($i,$j) 1
      $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
        [expr $glob(org) + ($j+1)*$v_width -1] [expr $glob(org) + ($i+1)*$v_height -1] \
        -fill $glob(rectcolor) -tag rect($i,$j) -width 1
  } elseif { $cache($i,$j) == 1 } {
      set cache($i,$j) 0
      $can_img delete rect($i,$j)
  }
  # on (re)encadre tout (a cause de l'approximation des nombres reels : effacement de traits) 
  #for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
  #  for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
  #    $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
  #      [expr $glob(org) + ($j+1)*$v_width -0] [expr $glob(org) + ($i+1)*$v_height -0] \
  #      -width 2
  #  }
  #}
  # activer/desactiver le pouce
  set n 0
  for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
    for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
      if { $cache($i,$j) == 1 } {
        set n 1
      }
    }
  }
  if { $n == 1 } {
    .bframe.but_pouce configure -state normal
  } else {
    .bframe.but_pouce configure -state disabled
  }
} ;# selectionner_rect

####################################################
#
# quadrillage
#
####################################################

proc row_quadrillage { n } {
  global glob can_img
  for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
        $can_img delete rect($i,$j)
      }
  }
  set glob(nbrow) $n
  quadrillage
}

proc col_quadrillage { n } {
  global glob can_img rect
  for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
        $can_img delete rect($i,$j)
      }
  }
  set glob(nbcol) $n
  quadrillage
}

proc clicwhat {can x y} {
  global glob v_width v_height
  set itot [expr $x- $glob(org)]
  set i [expr $itot/$v_width]

  set jtot [expr $y- $glob(org)]
  set j [expr $jtot/$v_height]
  if {$i>=0 && $j>= 0 && $i < $glob(nbcol) && $j < $glob(nbrow)} {
    selectionner_rect $can $j $i
  }
}

proc quadrillage { } {
  global can_img can_zones glob cache cadre rect bgimage v_width v_height fichier_image
  catch { delete cache }
  $can_zones delete all
    $can_img delete all

  # initialiser la sauvegarde des zones
  set glob(nzone) 0
  set glob(list_zones) [list "$glob(nbrow) $glob(nbcol)"]

  set bgimg $fichier_image
  
  set bgimage [image create photo -file [file join images $bgimg]]

  set hbgimage [image height $bgimage]
  set wbgimage [image width $bgimage]

  $can_img create image \
	[expr $glob(org) + int($wbgimage/2)+1] [expr $glob(org) + int($hbgimage/2)+1] -image $bgimage

  set v_height [expr ($hbgimage + $glob(nbrow)) / $glob(nbrow) +0]
  set v_width [expr ($wbgimage + $glob(nbcol)) / $glob(nbcol) +0]

    for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
      for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
        $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
	  [expr $glob(org) + ($j+1)*$v_width +1] [expr $glob(org) + ($i+1)*$v_height +1] \
	  -width 1 -tags vtag($i,$j)
      }
    }

  # on encadre tout
  for {set i 0} {$i < $glob(nbrow)} {incr i 1} {
    for {set j 0} {$j < $glob(nbcol)} {incr j 1} {
      $can_img create rect [expr $glob(org) + $j*$v_width +1] [expr $glob(org) + $i*$v_height +1] \
        [expr $glob(org) + ($j+1)*$v_width -0] [expr $glob(org) + ($i+1)*$v_height -0] \
        -width 1 -tag rect($i,$j)
      set cache($i,$j) 0  
    }
  }
 
  bind $can_img <Button-1> "clicwhat $can_img %x %y"

} ;# quadrillage

# #################################################################################
#
#                                   main
#
# #################################################################################

proc main { can_img } {
  global glob bgimg bgimage fichier_image
 
  $can_img delete all

  # afficher l'image sélectionnée
  set bgimg $fichier_image
  set bgimage [image create photo -file [file join images $bgimg]]

  # On utilise des rectangles pour dessiner les cases
  quadrillage    

} ;# main

#####################################################################################
#
# fenetre principale
#
#      placement de la fenetre en haut et a gauche de l'ecran
#
#####################################################################################
#wm resizable . 0 0
#wm geometry . [expr [winfo screenwidth .]-10]x[expr [winfo screenheight .]-80]+0+0
. configure -bg $glob(bgcolor)
  wm title . "[mc title_ed] : [file rootname $fichier_image]"

frame .frame -bg $glob(bgcolor)
pack .frame -side top -fill both -expand yes

# ################ On cree un canvas image ###########################################
# a gauche

set can_img .frame.c
canvas $can_img -width $glob(width) -height $glob(height) -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $can_img -side left -expand true 

# ####################################################################################
# une frame a droite de ce canvas

set f .frame.d 
frame $f -bg $glob(bgcolor)
pack $f -side left -expand true

# ################ On y cree un canvas parametres ####################################

set can_parametres $f.d
canvas $can_parametres -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $can_parametres -side top -expand true 

  # nombre lignes / colonnes
  set glob(nbrow) 4
  scale $can_parametres.nbrow -from 3 -to 30 -label [mc nbrow] -orient horizontal \
    -borderwidth 4 -length 140 -relief groove -variable nbrow  \
    -command row_quadrillage
  set nbrow $glob(nbrow)
  grid $can_parametres.nbrow -row 0 -column 1 -padx 10

  set glob(nbcol) 5
  scale $can_parametres.nbcol -from 3 -to 30 -label [mc nbcol] -orient horizontal \
    -borderwidth 4 -length 140 -relief groove -variable nbcol  \
    -command col_quadrillage
  set nbcol $glob(nbcol)
  grid $can_parametres.nbcol -row 0 -column 2 -padx 10

  set glob(nbmax) $glob(nbcol) ;# ?

# ############## On y cree un canvas pour numeros et descriptions de zones ###########
set can_zones $f.e
canvas $can_zones -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $can_zones -side top -expand true    
  
# ############# on cree une frame pour pouce, porte ##################################
# en bas

frame .bframe -bg $glob(bgcolor)
pack .bframe -side bottom -expand true

  button .bframe.but_pouce -image \
    [image create photo fpouce \
    -file [file join sysdata pouce.png]] \
    -state disabled \
    -command "ajouter_zone $can_zones"
  grid .bframe.but_pouce -padx 10 -column 1 -row 1


  button .bframe.but_quitter -image \
    [image create photo fquitter \
    -file [file join sysdata quitter_minus.png]] \
    -command "sauvegarde; lanceappli editeur.tcl"
  grid .bframe.but_quitter -padx 10 -column 3 -row 1

main $can_img
